Skip to main content
`Ctrl`+`K`

# to_vertex_cover

to_vertex_cover(G, matching, top_nodes=None)

  Returns the minimum vertex cover corresponding to the given maximum matching of the bipartite graph `G`.

  Parameters:
    G NetworkX graph

      Undirected bipartite graph

    matching dictionary

      A dictionary whose keys are vertices in `G` and whose values are the distinct neighbors comprising the maximum matching for `G`, as returned by, for example, `maximum_matching()`. The dictionary must represent the maximum matching.

    top_nodes container

      Container with all nodes in one bipartite node set. If not supplied it will be computed. But if more than one solution exists an exception will be raised.

  Returns:
    vertex_cover `set`

      The minimum vertex cover in `G`.

  Raises:
    AmbiguousSolution

      Raised if the input bipartite graph is disconnected and no container with all nodes in one bipartite set is provided. When determining the nodes in each bipartite set more than one valid solution is possible if the input graph is disconnected.

  Notes

  This function is implemented using the procedure guaranteed by Konig’s theorem, which proves an equivalence between a maximum matching and a minimum vertex cover in bipartite graphs.

  Since a minimum vertex cover is the complement of a maximum independent set for any graph, one can compute the maximum independent set of a bipartite graph this way:

      >>> G = nx.complete_bipartite_graph(2, 3)
      >>> matching = nx.bipartite.maximum_matching(G)
      >>> vertex_cover = nx.bipartite.to_vertex_cover(G, matching)
      >>> independent_set = set(G) - vertex_cover
      >>> print(list(independent_set))
      [2, 3, 4]

  See `bipartite documentation` for further details on how bipartite graphs are handled in NetworkX.